﻿; ───────────────────────────────────────────────────────────────────────────
; Драйвер расширенной арифметики
; это дизассемблированный исходник из прошивки ПЗУ 326
; для него есть исходник на Macro-11
; и тут есть ошибки
; ───────────────────────────────────────────────────────────────────────────

; эмуляция прерывания по вектору 4
EXT$V4: MOV     @#6, -(SP)      ; в стек PS вектора 4
        BIS     #1, (SP)        ; установим там бит С
        MOV     @#4, -(SP)      ; в стек адрес вектора 4
        RTI                     ; и переходим.
        ; в стеке остались PS/PC выхода из вектора 10.
        ; они будут использоваться при выходе из вектора 4
        ; или, если там стек напрямую инициализируется, то они не нужны
; ───────────────────────────────────────────────────────────────────────────
;точка входа в драйвер расширенной арифметики.
;вход - прерывание по вектору 10
EXT:    MOV     #6, -(SP)
        ADD     SP, (SP)        ; тут получается значение стека до возникновения прерывания
                                ; это нужно, если для передачи параметров fis использовался SP
        MOV     R5, -(SP)
        MOV     R4, -(SP)
        MOV     6(SP), R5       ; берём адрес возврата из прерывания
        MOV     -(R5), R4       ; получаем опкод, вызвавший прерывание
        MOV     R3, -(SP)
        MOV     R2, -(SP)
        MOV     R1, -(SP)
        MOV     R0, -(SP)
        MOV     R4, R0          ; опкод
        MOV     R0, R1          ; ещё раз
        CMP     R0, #75000      ; это fis ?
        BHIS    FLOAT$          ; скорее всего да, пойдём проверим
        JMP     EXTAR$          ; нет, может eis? пойдём проверим
; ───────────────────────────────────────────────────────────────────────────
        ADD     #6, SP          ; мусор
ERRCM$: CALL    RESTR$          ; восстановим регистры
        JMP     EXT$V4          ; и сделаем якобы прерывание по вектору 4

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;п/п установки признаков и восстановления регистров
RSTRS$: BIC     #17, 22(SP)     ; чистим поле признаков в PS возврата из прерывания
        BIS     R5, 22(SP)      ; и устанавливаем там свои

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;п/п восстановления регистров
RESTR$: MOV     (SP)+, 14(SP)   ; берём адрес возврата из RESTR$ или RSTRS$, и сохраняем его
                                ; на месте значения 6+SP
        MOV     (SP)+, R0       ; восстанавливаем все регистры
        MOV     (SP)+, R1
        MOV     (SP)+, R2
        MOV     (SP)+, R3
        MOV     (SP)+, R4
        MOV     (SP)+, R5
        RETURN                  ; и выходим из п/п. Теперь в стеке только PC PS
                                ; для выхода из прерывания
; End of function RESTR$
; End of function RSTRS$

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;умножение R0:R1 = R3:R4 * R5
IMUL32: CLR     R1              ; тут накапливается результат
        CLR     R0
        ROR     R5              ; B.hi >> 1
        BR      1$

2$:     ASR     R5
1$:     BCS     3$              ; если 1, то пойдём делать сложение
        BNE     4$              ; если 0, но ещё есть биты, то пойдём просто сдвигать
        BR      5$              ; если всё - то выход.

3$:     ADD     R4, R1          ; R0:R1 += R3:R4
        ADC     R0
        ADD     R3, R0
4$:     ASL     R4              ; R3:R4 <<= 1
        ROL     R3
        BR      2$              ; и повторим

5$:     RETURN                  ; как-то не оптимально. можно 2 слова сэкономить
; End of function IMUL32

; ───────────────────────────────────────────────────────────────────────────
FLOAT$: CMP     R0, #75040      ; точно fis ?
        BLO     1$              ; да
        JMP     ERRCM$          ; нет - другие не эмулируемые опкоды
; ───────────────────────────────────────────────────────────────────────────
1$:     BIC     #177747, R0     ; определим тип опкода
        ASR     R0
        ASR     R0              ; номер опкода * 2
        BIC     #177770, R1     ; определим номер используемого регистра
        ASL     R1              ; регистр * 2
        ADD     SP, R1          ; это адрес в стеке, где сохранено значение регистра
        MOV     R1, -(SP)       ; и сохраним его в стеке. Туда результат ещё писать надо будет
        MOV     (R1), R1        ; достанем значение регистра
        MOV     (R1)+, R2       ; B.hi
        MOV     (R1)+, R3       ; B.lo
        MOV     (R1)+, R4       ; A.hi
        MOV     (R1)+, R5       ; A.lo
        MOV     R1, -(SP)       ; и снова сохраним
        ADD     PC, R0
        ADD     #OFSTBL-., R0
        ADD     (R0), PC        ; и пойдём обрабатывать конкретную операцию
OFSTBL: .WORD   FADD$-OFSTBL    ; 75000
        .WORD   FSUB$-OFSTBL    ; 75010
        .WORD   FMUL$-OFSTBL    ; 75020
        .WORD   FDIV$-OFSTBL    ; 75030
; ───────────────────────────────────────────────────────────────────────────
;деление A = A / B
FDIV$:  CLR     -(SP)           ; флаг знака результата
        MOV     R2, R0          ; сохраним порядок B
        BGT     1$              ; если больше 0 - переход туда
        BLT     2$              ; если меньше 0 - переход туда
        JMP     FERR$           ; если равно 0 - ошибка, на 0 делить нельзя
; ───────────────────────────────────────────────────────────────────────────
2$:     INC     (SP)            ; отмечаем смену знака результата
1$:     MOV     R4, R1          ; сохраним порядок A
        BEQ     F3$             ; если это 0, то результат деления == 0
        BPL     4$              ; если больше 0 - переход
        INC     (SP)            ; отмечаем смену знака результата
4$:     CALL    SEPAR           ; разделяем мантиссу и порядок
        SUB     R0, R1          ; res.exp = A.exp - B.exp
        ADD     #37600, R1      ; ?
        MOV     R1, -(SP)       ; сохраняем
        MOV     #100, R1        ; начальное значение, бит, по которому будет выход из цикла
        CLR     R0
        BR      5$              ; и идём просто делить R4:R5 на R2:R3
; ───────────────────────────────────────────────────────────────────────────
6$:     ASL     R5
        ROL     R4
5$:     SUB     R3, R5
        SBC     R4
        SUB     R2, R4
        BMI     7$
8$:     SEC
        ROL     R1
        ROL     R0
        BCC     6$
        BR      9$
; ───────────────────────────────────────────────────────────────────────────
10$:    ASL     R5
        ROL     R4
        ADD     R3, R5
        ADC     R4
        ADD     R2, R4
        BPL     8$
7$:     CLC
        ROL     R1
        ROL     R0
        BCC     10$
9$:     MOV     R0, R2          ; вот результат
        MOV     R1, R3          ; тут R1 == R3
        JMP     NRRT$           ; и по идее, R1 не нужен, при сдвиге вправо
; ───────────────────────────────────────────────────────────────────────────
F3$:    TST     (SP)+
        CLR     R2
        CLR     R3
        JMP     FL$NZ$          ; установка признаков N и Z
; ───────────────────────────────────────────────────────────────────────────
;умножение A = A * B
FMUL$:  CLR     -(SP)           ; флаг знака
        MOV     R2, R0          ; сохраним порядок B
        BEQ     F3$             ; если это 0, то результат умножения == 0
        BPL     1$              ; если > 0, то переход
        INC     (SP)            ; иначе результат будет отрицательный
1$:     MOV     R4, R1          ; сохраним порядок A
        BEQ     F3$             ; если это 0, то результат умножения == 0
        BPL     2$              ; если > 0, то переход
        INC     (SP)            ; иначе результат будет отрицательный, или, если B было <0, то положительный
2$:     CALL    SEPAR           ; разделяем мантиссу и порядок
        ADD     R0, R1          ; res.exp = A.exp + B.exp
        SUB     #40000, R1      ; ?
        MOV     R1, -(SP)       ; порядок результата
        MOV     R5, -(SP)       ; A.m.lo ->
        MOV     R4, -(SP)       ; A.m.hi ->
        MOV     R3, -(SP)       ; B.m.lo ->
        MOV     R4, R3          ; A.m.hi
        MOV     R5, R4          ; A.m.lo
        MOV     R2, R5          ; B.m.hi
        CALL    IMUL32          ; умножение R0:R1 = R3:R4 * R5
                                ; умножаем A.m на B.m.hi
        MOV     R1, -(SP)       ; результат сохраним
        MOV     R0, -(SP)
        MOV     4(SP), R5       ; B.m.lo
        BEQ     3$              ; если 0, незачем умножать
        MOV     6(SP), R4       ; А.m.hi
        CLR     R3
        CALL    IMUL32          ; умножение R0:R1 = R3:R4 * R5
                                ; умножаем A.m.hi на B.m.lo
        ADD     R1, 2(SP)       ; складываем с предыдущем результатом
        ADC     (SP)
        ADD     R0, (SP)
        MOV     10(SP), R4      ; A.m.lo
        BEQ     3$              ; если 0, незачем умножать
        MOV     4(SP), R5       ; B.m.lo
        CLR     R3
        CALL    IMUL32          ; умножение R0:R1 = R3:R4 * R5
                                ; умножаем A.m.lo на B.m.lo
        ADD     R0, 2(SP)       ; складываем с предыдущем результатом
        ADC     (SP)
                                ; что-то не пойму логику.
                                ; res = A.m * B.m.hi + (A.m.hi + A.m.lo) * B.m.lo
3$:     CLR     R2
        BISB    1(SP), R2       ; берём старший байт ст слова результата
        MOV     2(SP), R1       ; берём мл слово результата
        SWAB    R1              ; переставляем байты
        MOVB    (SP)+, (SP)     ; замещаем младший байт мл слова младшим байтом ст слова результата
        MOV     (SP)+, R3       ; и достаём это
        SWAB    R3              ; переставляем байты
                                ; в результате получается res = R2:R3:R1
                                ; в старшем байте R2 - 0, в младшем байте R1 - незначащий мусор
        ADD     #6, SP          ; освобождаем стек
        JMP     NRLT$

; ███████████████ S U B R O U T I N E ███████████████████████████████████████

SEPAR:  BIC     #100177, R0     ; выделяем порядок B (B.exp)
        BIC     #100177, R1     ; выделяем порядок A (A.exp)
        BIC     #177600, R2     ; выделяем мантиссу B (B.m)
        BIC     #177600, R4     ; выделяем мантиссу A (A.m)
        BIS     #200, R2        ; добавляем подразумеваемый бит в B.m
        BIS     #200, R4        ; добавляем подразумеваемый бит в A.m
        RETURN
; End of function SEPAR

; ───────────────────────────────────────────────────────────────────────────
;вычитание A = A - B - это A + (-B)
FSUB$:  TST     R2              ; B == 0 ?
;тут таки не учитывается, что если порядок 0, то в мантиссе может быть
;любой мусор, он должен просто игнорироваться.
        BEQ     FADD$           ; да, пойдём, прибавим 0
        ADD     #100000, R2     ; иначе, поменяем знак B = -B
;сложение A = A + B
FADD$:  MOV     R2, R0          ; что мы там прибавляем?
        BNE     1$              ; не ноль
        MOV     R4, R2          ; а если 0, то просто
        MOV     R5, R3          ; res = A
        BR      FL$NZ$          ; установка признаков N и Z
; ───────────────────────────────────────────────────────────────────────────
1$:     MOV     R4, R1          ; а если A == 0, то res = B
        BEQ     FL$NZ$          ; установка признаков N и Z
        BIC     #177600, R2     ; оставляем в R2:R3 только мантиссу B (B.m)
        BIS     #200, R2        ; добавляем подразумеваемый бит
        TST     R0              ; а число B какое?
        BPL     2$              ; положительное
        NEG     R3              ; отрицательное - поменяем знак мантиссы
        ADC     R2
        NEG     R2
2$:     BIC     #177600, R4     ; оставляем в R4:R5 только мантиссу A (A.m)
        BIS     #200, R4        ; добавляем подразумеваемый бит
        TST     R1              ; а число A какое?
        BPL     3$              ; положительное
        NEG     R5              ; отрицательное - поменяем знак мантиссы
        ADC     R4
        NEG     R4
3$:     BIC     #100177, R0     ; это порядок B (B.exp)
        BIC     #100177, R1     ; это порядок A (A.exp)
        CLR     -(SP)           ; флаг знака
        MOV     R0, -(SP)       ; B.exp
        SUB     R1, R0          ; B.exp = B.exp - A.exp
        BHI     4$              ; если B.exp > A.exp
        BLO     5$              ; если B.exp < A.exp
        ;если B.exp == A.exp
        CLR     R1              ; B.exp = A.exp = 0
        BR      6$

;B.exp < A.exp
5$:     MOV     R1, (SP)        ; вместо B.exp поместим A.exp
        NEG     R0              ; A.exp - B.exp
        MOV     R2, R1          ; B.m <--> A.m
        MOV     R4, R2          ; меняем местами мантиссы A и B
        MOV     R1, R4
        MOV     R3, R1
        MOV     R5, R3
        MOV     R1, R5
;B.exp > A.exp
4$:     CLR     R1              ; tmp = 0 (вытесненные биты из выровненной мантиссы)
        CMP     R0, #6000
        BLE     7$              ; B.exp - A.exp <= 24.
        CLR     R4              ; если больше, то A.m = 0
        CLR     R5
        BR      6$
;B.exp - A.exp <= 24.
7$:     ASL     R0
        SWAB    R0              ; разность B.exp - A.exp в мл байт
;выравниваем мантиссы в соответствии с порядками.
8$:     ASR     R4              ; и двигаем A.m вправо
        ROR     R5
        ROR     R1              ; а сюда принимаем биты
        SOB     R0, 8$

6$:     ADD     R5, R3          ; res.m = B.m + A.m
        ADC     R2
        ADD     R4, R2
        BPL     9$              ; если >= 0, переход
        NEG     R1              ; иначе меняем знак
        ADC     R3
        ADC     R2
        NEG     R3
        ADC     R2
        NEG     R2
        INC     2(SP)           ; и фиксируем этот факт

9$:     MOV     R3, R4          ; проверяем, что получилось
        BIS     R1, R4
        BIS     R2, R4
        BNE     NRRT$           ; что-то получилось - переход
        CMP     (SP)+, (SP)+    ; все нули, освобождаем стек
        BR      FL$NZ$          ; установка признаков N и Z
; ───────────────────────────────────────────────────────────────────────────
; сдвигаем мантиссу вправо
NRRT$:  CMP     R2, #400        ; res.hi умещается в мл байт?
        BLO     NRLT$           ; да
        ASR     R2              ; нет, двигаем вправо
        ROR     R3
        ROR     R1
        ADD     #200, (SP)      ; считаем кол-во сдвигов (это добавка к порядку)
        BR      NRRT$           ; и так пока не станет умещаться.
; ───────────────────────────────────────────────────────────────────────────
; сдвигаем мантиссу влево
NRLT$:  TSTB    R2              ; старший бит мантиссы == 1 ?
        BMI     1$              ; да
2$:     SUB     #200, (SP)      ; нет - считаем кол-во сдвигов
        ASL     R1              ; двигаем влево
        ROL     R3
        ROLB    R2
        BPL     2$              ; и так, пока старший бит мантиссы не станет 1

1$:     ASL     R1              ; округляем до двухсловного числа
        ADC     R3
        ADCB    R2
        BCC     3$              ; переполнения не случилось?
        ADD     #200, (SP)      ; случилось - скорректируем порядок.
3$:     MOV     (SP)+, R4       ; достаём порядок из стека
        ;ОШИБКА!!! пропущена команда BEQ F5$
        BPL     4$              ; если >=0, то переход
        CLR     R5              ; а иначе - переполнение  ОШИБКА!!! эта команда должна быть перед извлечением R4 из стека
        ROL     R4              ; двигаем порядок влево
        BPL     F6$             ; если стало >=0, то V
        BR      F5$             ; иначе N и V
        ;по идее, тут ещё и C должно формироваться, если С==1, но нет.
; ───────────────────────────────────────────────────────────────────────────
4$:     ROR     (SP)+           ; достаём знак результата
        BCC     6$              ; если +, то переход
        BIS     #100000, R2     ; если -, то формируем знаковый бит
6$:     BIC     #200, R2        ; очищаем подразумеваемый бит мантиссы
        BIS     R4, R2          ; помещаем порядок на место

;установка признаков N и Z
FL$NZ$: CLR     R5              ; тут формируются признаки
        TST     R2              ; res.hi == 0 ?
        BNE     1$              ; нет
        BIS     #4, R5          ; да - формируем Z
1$:     BPL     2$              ; res.hi >= 0 или просто переход после bis
        BIS     #10, R5         ; res.hi < 0 - формируем N
2$:     MOV     (SP)+, R1       ; конец блока параметров
        MOV     (SP)+, R0       ; адрес в стеке, где хранится значение используемого регистра
        MOV     R3, -(R1)       ; сохраняем res на место A
        MOV     R2, -(R1)
        MOV     R1, (R0)        ; а адрес res - в регистр
        SUB     SP, R0          ; а теперь проверим, какой это был регистр
        CMP     R0, #14
        BLO     3$              ; если это R0-R5, то всё как обычно
        BEQ     4$              ; если это SP
        ADD     #4, 16(SP)      ; если это PC - то он должен указывать за res,
                                ; а не на него, как все остальные регистры
3$:     CALL    RSTRS$          ; установим признаки из R5 и восстановим регистры
        RTI
; ───────────────────────────────────────────────────────────────────────────
4$:     CALL    RSTRS$          ; установим признаки из R5 и восстановим регистры
        MOV     (SP)+, 2(SP)    ; переместим PS/PC в стеке на место B,
        MOV     (SP)+, 2(SP)    ; оно всё равно не нужно
        RTI                     ; и выходим. Изящно получается со стеком в качестве буфера
; ───────────────────────────────────────────────────────────────────────────

FERR$:  BIS     #1, R5          ; формируем C     ОШИБКА!!! должно быть MOV #1,R5
F5$:    BIS     #10, R5         ; формируем N
F6$:    BIS     #2, R5          ; формируем V
        CMP     (SP)+, (SP)+    ; убираем из стека флаг знака и конец блока параметров fis
        MOV     (SP)+, R0       ; достаём адрес в стеке, где хранится значение используемого регистра
        SUB     SP, R0          ; проверим, какой это был регистр
        CMP     R0, #16         ; это PC?
        BNE     1$              ; нет
        ADD     #10, 16(SP)     ; да - передвинем его за блок параметров
1$:     CALL    RSTRS$          ; установим признаки из R5 и восстановим регистры
        MOV     @#246, -(SP)    ; эмулируем возникновение прерывания по ошибке
        MOV     @#244, -(SP)    ; СППЗ
        RTI                     ; если кто об этом не знал, ему же хуже.
; ───────────────────────────────────────────────────────────────────────────

EXTAR$: CMP     R0, #70000      ; точно eis?
        BHIS    1$              ; да
        JMP     ERRCM$          ; нет - другие не эмулируемые опкоды
; ───────────────────────────────────────────────────────────────────────────
1$:     BIC     #170777, R0     ; выделим код опкода
        SWAB    R0              ; вот он уже умноженный на 2
        MOV     R1, R2
        BIC     #177770, R1     ; выделим регистр источника
        ROL     R1              ; *2
        ASR     R2
        ASR     R2
        MOV     R2, R3
        BIC     #177761, R2     ; выделим код адресации источника *2
        ASR     R3
        ASR     R3
        ASR     R3
        BIC     #177761, R3     ; выделим регистр приёмника *2
        MOV     #2, R4
        BIS     R3, R4          ; а это R+1 приёмника
        ADD     SP, R3          ; находим адрес в стеке, где находится содержимое регистров приёмника
        ADD     SP, R4
        MOV     R1, -(SP)       ; регистр источника сохраним
        ADD     SP, R1          ; находим адрес в стеке, где находится содержимое регистра источника
        ADD     #2, R1
        MOV     R2, -(SP)       ; адресацию источника в стек
        ADD     PC, (SP)        ; и сформируем там адрес перехода
        ADD     #EPCBS2-., (SP) ; а при этом у нас R5 свободен
        ADD     @(SP)+, PC      ; зачем надо было стек использовать, непонятно
EPCBS2: .WORD   ADDR01-EPCBS2   ; 0 Rx
        .WORD   ADDR01-EPCBS2   ; 1 (Rx)
        .WORD   ADDR23-EPCBS2   ; 2 (Rx)+
        .WORD   ADDR23-EPCBS2   ; 3 @(Rx)+
        .WORD   ADDR45-EPCBS2   ; 4 -(Rx)
        .WORD   ADDR45-EPCBS2   ; 5 @-(Rx)
        .WORD   ADDR67-EPCBS2   ; 6 n(Rx)
        .WORD   ADDR67-EPCBS2   ; 7 @n(Rx)
; ─ автоинкрементная адресация ──────────────────────────────────────────────
ADDR23: INC     (SP)            ; номер регистра источника ++ - признак автоинкрементной адресации
        MOV     (R1), R5        ; берём содержимое регистра источника
        ADD     #2, (R1)        ; инкрементируем
        BR      ARROP$
; ─ автодекрементная адресация ──────────────────────────────────────────────
ADDR45: SUB     #2, (R1)        ; декрементируем
        MOV     (R1), R5        ; берём содержимое регистра источника
        BR      ARROP$
; ─ индексная адресация ─────────────────────────────────────────────────────
ADDR67: MOV     @20(SP), R5     ; берём индекс по содержимому PC
        ADD     #2, 20(SP)      ; прибавляем к содержимому PC два
        ADD     (R1), R5        ; прибавляем к индексу содержимое регистра источника
        BR      ARROP$
; ─ регистровая адресация ───────────────────────────────────────────────────
ADDR01: MOV     R1, R5          ; берём регистр источник
ARROP$: BIT     #2, R2          ; адресация относительная?
        BEQ     1$              ; нет
        MOV     (R5), R5        ; да - значит получим значение по адресу значения
1$:     MOV     R4, -(SP)       ; R+1 приёмника
        MOV     R3, -(SP)       ; R приёмника
        ADD     PC, R0
        ADD     #OFSTB2-., R0
        ADD     (R0), PC
OFSTB2: .WORD   MUL$-OFSTB2     ; 70000
        .WORD   DIV$-OFSTB2     ; 71000
        .WORD   ASH$-OFSTB2     ; 72000
        .WORD   ASHC$-OFSTB2    ; 73000
        .WORD   XOR$-OFSTB2     ; 74000
; ───────────────────────────────────────────────────────────────────────────
; умножение R:R+1 = R * ss
MUL$:   MOV     (R3), R4        ; берём мл. часть
        BEQ     2$              ; если 0, то результат 0
        MOV     (R5), R5        ; берём источник
        BEQ     2$              ; если 0, то результат 0
        BPL     1$              ; если >= 0, то идём умножать
        NEG     R4              ; иначе R4 = -R4
        NEG     R5              ; R5 = -R5
        BPL     1$              ; если >= 0, то идём умножать
                                ; иначе в R5 число 100000
        MOV     R4, R3          ; R4 <-> R5
        MOV     R5, R4
        MOV     R3, R5
        BPL     1$              ; если >= 0, то идём умножать
        NEG     R5              ; иначе R5 = -R5
        BMI     4$              ; если < 0, то и в R4 тоже было число 100000
1$:     TST     R4              ; умножаем
        SXT     R3
        CALL    IMUL32          ; умножение R0:R1 = R3:R4 * R5
                                ; на выходе в R5 нуль
        TST     R1              ; посмотрим
        SXT     R2              ; какой знак у мл. части
        CMP     R0, R2          ; если знак распространён на ст. часть
        BEQ     3$              ; то всё нормально
        BIS     #1, R5          ; иначе бит C
3$:     JMP     EARX1$

2$:     CLR     R0              ; результат
        CLR     R1
        CLR     R5              ; флаги
        JMP     EARX1$          ; выходим

4$:     MOV     #40000, R0      ;результат умножения 100000 * 100000
        CLR     R1
        CLR     R5
        BR      3$
; ───────────────────────────────────────────────────────────────────────────
; деление R = R:R+1 / ss , R+1 = R:R+1 % ss
DIV$:   CLR     -(SP)           ; флаг знака результата
        MOV     (R3), R0        ; значение R приёмника
        MOV     (R4), R1        ; значение R+1 приёмника
        MOV     R0, -(SP)
        BPL     1$
        INC     2(SP)
        NEG     R1
        ADC     R0
        NEG     R0
        BMI     2$
1$:     MOV     (R5), R4
        BEQ     3$
        BPL     4$
        INC     2(SP)
        NEG     R4
        BMI     2$
4$:     CLR     R5
        CMP     R0, R4
        BGT     2$
        BLT     5$
        CMP     R1, R4
        BHIS    2$
5$:     CLR     R2
        MOV     #20, R3
6$:     ASR     R4
        ROR     R5
        SUB     R5, R1
        SBC     R0
        SUB     R4, R0
        BMI     7$
8$:     SEC
        ROL     R2
        SOB     R3, 6$
        BR      9$

10$:    ASR     R4
        ROR     R5
        ADD     R5, R1
        ADC     R0
        ADD     R4, R0
        BPL     8$
7$:     CLC
        ROL     R2
        SOB     R3, 10$
        ADD     R5, R1
9$:     TST     (SP)+
        BPL     11$
        NEG     R1
11$:    ASR     (SP)+
        BCC     12$
        NEG     R2
12$:    CLR     R5
        MOV     R2, R0
        BPL     13$
        BIS     #10, R5         ;N
13$:    BNE     14$
        BIS     #4, R5          ;Z
14$:    JMP     EARX2$

3$:     MOV     #3, R5          ; флаги VC
        BR      15$

2$:     MOV     #2, R5          ; переполнение V
15$:    ADD     #10, SP         ; результат не сохраняется
        JMP     EARX3$

; ███████████████ S U B R O U T I N E ███████████████████████████████████████
;получаем R и число битов для сдвигаем
;выход: R2 = 0
;       R0 = R
;       R5 = счётчик сдвигов
;       Z - в счётчике 0
;       С - сдвиг вправо
SRCASH: CLR     R2
        MOV     (R3), R0        ; значение R приёмника
        MOV     (R5), R5        ; значение источника
        BIT     #40, R5         ; смотрим знак
        BEQ     1$              ; +
        BIS     #177700, R5     ; - , устанавливаем биты
        NEG     R5              ; и меняем знак
        RETURN

1$:     BIC     #177700, R5     ; очищаем биты
        RETURN
; End of function SRCASH

; ───────────────────────────────────────────────────────────────────────────
;арифметический сдвиг R = R << ss / R = R >> ss
ASH$:   MOV     R3, 2(SP)       ; R+1 заменяем на R
        CALL    SRCASH          ; подготовка
        BEQ     1$              ; 0, не надо ничего двигать
        BCS     2$              ; двигать вправо
3$:     ASL     R0              ; двигаем влево
        BVC     4$
        INC     R2              ; а тут отмечаем возникновение бита V
4$:     SOB     R5, 3$          ; на заданное количество бит
        BR      1$

2$:     ASR     R0              ; двигаем вправо, тут переполнения не бывает
        SOB     R5, 2$          ; на заданное количество бит
1$:     MOV     R0, R1          ; результат дублируем и для R+1
        BR      EARX4$
; ───────────────────────────────────────────────────────────────────────────
;арифметический сдвиг R:R+1 = R:R+1 << ss / R:R+1 = R:R+1 >> ss
ASHC$:  MOV     (R4), R1        ; значение R+1 приёмника
        CALL    SRCASH          ; подготовка
        BEQ     EARX4$          ; 0, не надо ничего двигать
        BCS     1$              ; двигать вправо
2$:     ASL     R1              ; двигаем влево
        ROL     R0
        BVC     3$
        INC     R2              ; а тут отмечаем возникновение бита V
3$:     SOB     R5, 2$          ; на заданное количество бит
        BR      EARX4$

1$:     ASR     R0              ; двигаем вправо, тут переполнения не бывает
        ROR     R1
        SOB     R5, 1$          ; на заданное количество бит
        BR      EARX4$
; ───────────────────────────────────────────────────────────────────────────
; операция исключающее или.
; dd = dd xor R
XOR$:   CMP     (SP)+, (SP)+    ;типа игнорируется? могли бы и заэмулировать. это не так и трудно
        BR      EARX3$
; ───────────────────────────────────────────────────────────────────────────
; вход только для ASH/ASHC
; вход: R0:R1 - результат
;       R5 - флаги
;       R2 - признак возникновения переполнения V
EARX4$: ADC     R5              ; ставим флаг C, если было
        TST     R2
        BEQ     EARX1$
        BIS     #2, R5          ; ставим флаг V
; вход: R0:R1 - результат
;       R5 - флаги
EARX1$: TST     R0              ; смотрим знак результата
        BPL     1$              ; >= 0
        BIS     #10, R5         ; < 0 - ставим флаг N
1$:     BNE     EARX2$          ; идём туда
        TST     R1
        BNE     EARX2$
        BIS     #4, R5          ; если R0:R1 == 0, ставим флаг Z
EARX2$: MOV     R0, @(SP)+      ; ст часть в R
        MOV     R1, @(SP)+      ; мл часть в R+1
EARX3$: CMP     (SP)+, #15      ; если регистр источник был SP и адресация была автоинкрементная
        BEQ     2$              ; то переход
        CALL    RSTRS$          ; установим признаки из R5 и восстановим регистры
        RTI                     ; и выходим
; ───────────────────────────────────────────────────────────────────────────
2$:     CALL    RSTRS$          ; установим признаки из R5 и восстановим регистры
        ; для автоинкрементной адресации со стеком, аргумент источника был в стеке, поэтому
        MOV     2(SP), 4(SP)    ; сдвинем PS/PC на место аргумента
        MOV     (SP)+, (SP)     ; сделаем освобождение стека от аргумента
        RTI                     ; и выходим

        .END


